<?php

declare(strict_types=1);

namespace Dedi\SyliusTaxonTypePlugin\Factory;

use Dedi\SyliusTaxonTypePlugin\Model\TypedTaxonInterface;
use Sylius\Component\Taxonomy\Factory\TaxonFactoryInterface as BaseTaxonFactoryInterface;

class TaxonFactory implements TaxonFactoryInterface
{
    private BaseTaxonFactoryInterface $decoratedFactory;

    public function __construct(BaseTaxonFactoryInterface $decoratedFactory)
    {
        $this->decoratedFactory = $decoratedFactory;
    }

    public function createNew(): TypedTaxonInterface
    {
        /** @var TypedTaxonInterface $taxon */
        $taxon = $this->decoratedFactory->createNew();
        $taxon->setType(TypedTaxonInterface::DEFAULT_TYPE);

        return $taxon;
    }

    public function createType(string $type): TypedTaxonInterface
    {
        /** @var TypedTaxonInterface $taxon */
        $taxon = $this->decoratedFactory->createNew();
        $taxon->setType($type);

        return $taxon;
    }
}
